var game = "game";
function zeig_cont(w)
{
 if(game != "")
  document.getElementById(game).style.visibility = "hidden";
 document.getElementById(w).style.visibility = "visible";
 game = w;
}

String.prototype.trim = function()
{
	var	str = this.replace(/^\s\s*/, ''),
		ws = /\s/,
		i = this.length;
	while (ws.test(str.charAt(--i)));
	return str.slice(0, i + 1);
}

// JavaScript Othello Game
// Copyright (c) 2000, 2001 Kelly Yancey <kbyanc@posi.net>
// All rights reserved.
//
// Redistribution and use in source form, with or without modification, is
// permitted provided that the following conditions are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer,
//    without modification, immediately at the beginning of the file.
// 2. All advertising materials mentioning features or use of this software
//    must display the following acknowledgement:
//      This product includes software developed by Kelly Yancey
//    and a reference to the URL http://www.posi.net/software/othello/
// 3. The name of the author may not be used to endorse or promote products
//    derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// game slightly modified by Jürgen Müller-Lütken 12/2011; kontakt@p-six.de

// Variables you can change
// messages
var			PlayerWhite = 'WEISS'; // white
var			PlayerBlack = 'SCHWARZ'; // black
var			PlayerTurn = ' ist am Zug'; // (black/white) to play
var			PlayerHasWon = ' hat das Spiel gewonnen'; // has won the game
var			PlayerMustPass = ' muss passen!'; // must pass
var			PlayerNoMoves = 'Es gibt keine Spielzüge mehr!'; // There are no more moves!
var			Draw = 'Unentschieden!'; // The game ends with a draw
var			gameboardColor = "#FC0";
// size of the pictures used to represent pieces (all pictures must be the same size)
var        piecewidth = 40;
var        pieceheight = 40;

// size of the board
var        width = 8;
var        height = 8;

// Do not change anything above here, if you don't know what you are doing
// picture numbers
var        EMPTY = 0;                // empty square
var        WHITE = 1;                // white piece
var        BLACK = 2;                // black piece
var        WHITETRANS = 3;                // white transparent cursor piece
var        BLACKTRANS = 4;                // black transparent cursor piece
var        NUMBASE = 5;                // beginning of numeric pictures


// define a mouse-over and per-turn handler...
var			overhook = 'window.status = PlayerWhite + ": " + score[WHITE] + ", " +PlayerBlack + ": " + score[BLACK]';
var 		turnhook = 'window.defaultStatus = PlayerWhite + ": " + score[WHITE] + ", " + PlayerBlack + ": " + score[BLACK]';

// set defaults
var 		human = BLACK;
var 		humanVsHuman = false;
var 		showcursor = true;
var 		showflips = false;
var 		weightsquares = true;
var 		edgesensitive = true;
var 		picture = new Array();


var LoadPieceImage = function(picnum, pictureURL) {
	// routine to associated the given picture with a picture number.
	    picture[picnum] = new Image();
	    picture[picnum].src = pictureURL;
}
// load player piece images
LoadPieceImage(EMPTY, "rev/blank.gif");
LoadPieceImage(WHITE, "rev/white.gif");
LoadPieceImage(BLACK, "rev/black.gif");
LoadPieceImage(WHITETRANS, "rev/white-trans.gif");
LoadPieceImage(BLACKTRANS, "rev/black-trans.gif");

// load number images (must have at least 0-21)
for(i = 0; i <= 21; i++)
    LoadPieceImage(NUMBASE + i, "rev/trans-" + i + ".gif");
	
// the class
function OthelloBoard(pieceWidth, pieceHeight, _human, _humanVsHuman, _showcursor, _showflips, _weightsquares, _edgesensitive, no)
{
	// board settings
	var		   _piecewidth = pieceWidth;
	var		   _pieceheight = pieceHeight;
	// player settings
	var        _Human = _human;
	var		   humanVsHuman = _humanVsHuman;      // play human versus human
	var        showcursor = _showcursor;        // display cursor showing user where they can go
	var        showflips = _showflips;        // display counts showing how many pieces they can flip by putting a piece in a given square

	// AI settings
	var        weightsquares = _weightsquares;        // whether AI prefers squares that yield higher flip counts
	var        edgesensitive = _edgesensitive;        // whether AI is sensitive to the importance of edge squares
	var		   _gameNo = no;

	// user-supplied expression to evaluate at the end of each round.
	var        roundhook = "";

	// some internal global variables
	var        board = new Array(width);
	var        score = new Array();
	score[1] = 0;
	score[2] = 0;
	var        turn = BLACK;
	var        AI_timerID;


	var     lastlookup = 0;
	var 	_self = this;
	var		_matrix = '';
	var		_moves = 0;
	var		_fmoves = 0;
	var		_lastMove = {'x' : -1, 'y' : -1};
	var		_History = [];
	var		_Gains = [];
	var		_GameplayStr = '';
	var		_Gameplay = [];
	var		_moveBack = false;
	var		_ie = false;
	var		_Notation = {'a':0, 'b':1, 'c':2, 'd':3, 'e':4, 'f':5, 'g':6, 'h':7, 0:'a', 1:'b', 2:'c', 3:'d', 4:'e', 5:'f', 6:'g', 7:'h'};
	

	function piece(imagename) {
	// object definition for 'piece' type
	    this.imagename = imagename;
	    this.player = EMPTY;
	    // how many pieces each player could flip by taking this square
	    this.flips = new Array();
	    this.flips[WHITE] = 0;
	    this.flips[BLACK] = 0;
	    // how valuable this location is to each player
	    this.value = new Array();
	    this.value[WHITE] = 0;
	    this.value[BLACK] = 0;
	}

	function SetPieceImage(x, y, src) {
	// routine to set the image associated with the given piece
	    if(document.images[board[x][y].imagename].src != src) {
	        // we explicitely check to see if we are changing the image source to prevent
	        // unnecessary redrawing of images which do not change
	        document.images[board[x][y].imagename].src = src;
	    }
	}

	this.InitializeBoard = function(color, container, matrix, moveFirst) {
		
		var div, table, tbody, tr, td, img, val, player;
		
		_ie = navigator.appName.indexOf('Microsoft') > -1;
		if(matrix) {
			_matrix = matrix;
			var s = _ie ? '\r' : '\n';
			var lines = _matrix.trim().split(s);
		}
	// routine to initialize the state of the game and draw the board
	    // build the board array
	    for(x = 0; x < width; x++)
		{
	        board[x] = new Array(height);
		}
		div = document.createElement('div');
		div.setAttribute('id', 'd_'+no);
		table = document.createElement('table');
		tbody = document.createElement('tbody');
		var _x = _y = 0;
	    for(y = 0; y < height + 2; y++) 
		{
			tr = document.createElement('tr');
			tbody.appendChild(tr);
			if(matrix && y > 0 && y < height + 1)
			{
				var tiles = lines[_y].trim().split('');
			}
	        for(x = 0; x < width + 2; x++) 
			{
	            // place initial pieces
				td = document.createElement('td');
				td.style.position = 'relative';
				td.style.backgroundColor = '#000';
				td.style.width = _piecewidth + 'px';
				td.style.height = _pieceheight + 'px';
				if(y == 0)
				{
					if((x > 0 && x < width + 1))
					{
						val = document.createTextNode(_Notation[x-1]);
						td.appendChild(val);
						tr.appendChild(td);
					}
					else
					{
						tr.appendChild(td);
					}
				}
				if(y > 0 && y < height + 1 && x == 0)
				{
					if(x == 0)
					{
						val = document.createTextNode(String(y));
						td.appendChild(val);
						tr.appendChild(td);
					}
				}
				else if(y > 0 && y < height + 1 && x > 0 && x < width + 1)
				{
					if(matrix)
					{
						switch(tiles[_x])
						{
							case 'O':
							player = WHITE;
							score[WHITE]++;
							_moves++;
							break;
							
							case '#':
							player = BLACK;
							score[BLACK]++;
							_moves++;
							break;
							
							case '.':
							player = EMPTY;
							break;
						}
					}
					else
					{
			            if((_x == (width/2)-1 && _y == (width/2)-1) || (_x == width/2 && _y == width/2)) {
							player = WHITE;
							score[WHITE]++;
						}
			            else if((_x == (width/2)-1 && _y == width/2) || (_x == width/2 && _y == (width/2)-1)) {
							player = BLACK;
							score[BLACK]++;
						}
			            else player = EMPTY;
					}
					td.style.backgroundColor = color;
					td.x = _x;
					td.y = _y;
					td.onclick = function() { _self.PutPiece(this.x, this.y); };
					td.onmouseover = function() { _self.CheckPutPiece(this.x, this.y); };
					td.onmouseout = function() { _self.RestorePiece(this.x, this.y); };
					img = document.createElement('img');
					img.setAttribute('name', 'c_'+no+'[' + _x + ',' + _y + ']');
					img.setAttribute('id', 'c_'+no+'[' + _x + ',' + _y + ']');
					img.setAttribute('src', picture[player].src);
					img.setAttribute('width', _piecewidth);
					img.setAttribute('height', _pieceheight);
					td.appendChild(img);
					tr.appendChild(td);
					board[_x][_y] = new piece('c_'+no+'[' + _x + ',' + _y + ']');
					board[_x][_y].player = player;
					_x++;
					if(_x > width - 1)
					{
						_x = 0;
					}
					
				}
				else if(y < height + 1)
				{
					tr.appendChild(td);
				}
				
				
	        }
			if(y > 0 && y < height + 1)
			{
				_y++;
			}
			tbody.appendChild(tr);
	    }
		table.appendChild(tbody);
		div.appendChild(table);
		container.appendChild(div);
		
		div = document.createElement('p');
		div.style.textAlign = 'center';
		container.appendChild(div);
		
		var but = document.createElement('button');
		but.setAttribute('type', 'button');
		but.setAttribute('class', 'back');
		but.i = _gameNo;
		val = document.createTextNode('<');
		but.onclick = function() { _self.MoveBack(); };
		but.appendChild(val);
		container.appendChild(but);
		
		but = document.createElement('button');
		but.setAttribute('type', 'button');
		but.setAttribute('class', 'forward');
		but.i = _gameNo;
		val = document.createTextNode('>');
		but.onclick = function() { _self.MoveForward(); };
		but.appendChild(val);
		container.appendChild(but);
		
		div = document.createElement('div');
		div.setAttribute('class', 'gamedata');
		
		val = document.createTextNode(PlayerBlack + ':');
		div.appendChild(val);
		var span = document.createElement('span');
		span.setAttribute('id', 'Game_' + _gameNo + 'Blacks');
		div.appendChild(span);
		
		val = document.createTextNode('Zug:');
		div.appendChild(val);
		span = document.createElement('span');
		span.setAttribute('id', 'Game_' + _gameNo + 'Moves');
		div.appendChild(span);
		
		val = document.createTextNode(PlayerWhite + ':');
		div.appendChild(val);
		span = document.createElement('span');
		span.setAttribute('id', 'Game_' + _gameNo + 'Whites');
		span.setAttribute('class', 'whiteScore');
		div.appendChild(span);
		container.appendChild(div);
		
		but = document.createElement('button');
		but.setAttribute('type', 'button');
		but.setAttribute('class', 'reset');
		but.i = _gameNo;
		val = document.createTextNode('Reset');
		but.onclick = function() { _self.ResetBoard(_human, true, true, false, weightsquares, edgesensitive, moveFirst); };
		but.appendChild(val);
		container.appendChild(but);
		
		
		// decrement the first four discs because they wern't set
		if(_moves > 0)
		{
			_moves -= 4;
		}
		ShowScore();
		ShowMessage((moveFirst == BLACK ? PlayerBlack : PlayerWhite) + PlayerTurn)
	}

	this.ResetBoard = function(_human, _humanVsHuman, _showcursor, _showflips, _weightsquares, _edgesensitive, moveFirst) {
	// routine to reset all of the pieces on the board
	    // cancel any pending AI task
	    if(AI_timerID != undefined) {
	        clearTimeout(AI_timerID);
	        AI_timerID = undefined;
	    }
		// remove marker of last move
		if(_moves >= 1 && typeof _History[_moves] != 'undefined')
		{
			var lastPiece = _History[_moves].split(',');
			UnmarkMove(lastPiece[0], lastPiece[1], _Human);
			_lastMove.x = -1;
			_lastMove.y = -1;
		}
		// reset scores
		score[WHITE] = 0;
		score[BLACK] = 0;
		_moves = 0;
		_fmoves = 0;
		_History = [];
		_Gains = [];
		_moveBack = false;

	    // reset the board
		if(_matrix)
		{
			var s = _ie ? '\r' : '\n';
			var lines = _matrix.trim().split(s);
			for(y = 1; y <= height; y++) {
		        for(x = 1; x <= width; x++) {
					var tiles = lines[y-1].trim().split('');
					switch(tiles[x-1])
					{
						case 'O':
						board[x-1][y-1].player = WHITE;
						SetPieceImage(x-1, y-1, picture[WHITE].src);
						score[WHITE]++;
						board[x-1][y-1].move = 0;
						_moves++;
						break;
						
						case '#':
						board[x-1][y-1].player = BLACK;
						SetPieceImage(x-1, y-1, picture[BLACK].src);
						score[BLACK]++;
						board[x-1][y-1].move = 0;
						_moves++;
						break;
						
						case '.':
						board[x-1][y-1].player = EMPTY;
						SetPieceImage(x-1, y-1, picture[EMPTY].src);
						break;
					}
		        }
		    }
			_moves -= 4;
		}
		else
		{
		    for(y = 1; y <= height; y++) {
		        for(x = 1; x <= width; x++) {
		            board[x-1][y-1].player = EMPTY;
		            SetPieceImage(x-1, y-1, picture[EMPTY].src);
		        }
		    }
		    // put initial pieces back on the board
		    RawPutPiece(width/2-1, width/2-1, WHITE);
		    RawPutPiece(width/2, width/2, WHITE);
		    RawPutPiece(width/2-1, width/2, BLACK);
		    RawPutPiece(width/2, width/2-1, BLACK);
		}
		
		humanVsHuman = _humanVsHuman;
		_Human = _human;
		showcursor = _showcursor;
		showflips = _showflips; 

		weightsquares = _weightsquares;
		edgesensitive = _edgesensitive; 
		
		if((str = document.getElementById('Game_' + _gameNo).parentNode.getElementsByTagName('input')[0].value) != '')
		{
			ReadGameplay(str);
		}
		document.getElementById('Input_' + _gameNo).value = '';
		
	    turn = BLACK;
	    if(turnhook != "") eval(turnhook);
		ShowScore();
		ShowMessage((moveFirst == BLACK ? PlayerBlack : PlayerWhite) + PlayerTurn)
	}
	
	function ShowScore(Text)
	{
		var obj1, obj2;
		if((obj1 = document.getElementById("Game_" + _gameNo + "Whites")) != null && (obj2 = document.getElementById("Game_" + _gameNo + "Blacks")) != null)
		{
			obj1.innerHTML = score[WHITE];
			obj2.innerHTML = score[BLACK];
		}
		if((obj1 = document.getElementById("Game_" + _gameNo + "Moves")) != null)
		{
			if(_History[_moves])
			{
				var lastPiece = _History[_moves].split(',');
				obj1.innerHTML = _moves + '.' + _Notation[lastPiece[0]] + String(Number(lastPiece[1]) + 1);
			}
			else
			{
				obj1.innerHTML = _moves
			}
		}
	}
	
	function ShowMessage(Message)
	{
		if(typeof Message == 'string')
		{
			document.getElementById("Game_" + _gameNo).parentNode.getElementsByTagName('p')[0].innerHTML = Message;
		}
	}

	function NumFlips(x, y, player) {
	    var deltax, deltay, distance;
	    var posx, posy;
	    var count = 0;

	    for(deltay = -1; deltay <= 1; deltay++) {
	        for(deltax = -1; deltax <= 1; deltax++) {
	            for(distance = 1;; distance++) {
	                posx = x + (distance * deltax);
	                posy = y + (distance * deltay);
	                // stop if we go off the board
	                if(posx < 0 || posx >= width || posy < 0 || posy >= height)
	                    break;
	                // stop when we reach an empty square
	                if(board[posx][posy].player == EMPTY)
	                    break;
	                // only update the flip count when we reach another of the
	                // player's pieces
	                if(board[posx][posy].player == player) {
	                    count += distance - 1;
	                    break;
	                }
	            }
	        }
	    }
	    return count;
	}

	function CalcFlipCounts() {
	    var x, y;

	    for(y = 0; y < height; y++) {
	        for(x = 0; x < width; x++) {
	            board[x][y].flips[WHITE] = 0;
	            board[x][y].flips[BLACK] = 0;

	            if(board[x][y].player != EMPTY) continue;

	            board[x][y].flips[WHITE] = NumFlips(x, y, WHITE);
	            board[x][y].flips[BLACK] = NumFlips(x, y, BLACK);
	        }
	    }
	}
	
	function RawPutPiece(x, y, player) {
	    var other = OtherPlayer(player);
	    if(board[x][y].player == other) score[other]--;

	    board[x][y].player = player;
	    SetPieceImage(x, y, picture[player].src);
	    score[player]++;
	}

	function FlipPieces(x, y, player) {
	    var deltax, deltay, distance;
	    var posx, posy;
	    var count = 0;
		
		// put a piece down at the desired location
		RawPutPiece(x, y, player);
		_History[++_moves] = x + ',' + y;
		ShowHistory();
		
		_Gains[_moves] = '';
	    for(deltay = -1; deltay <= 1; deltay++) {
	        for(deltax = -1; deltax <= 1; deltax++) {
	            for(distance = 1; distance <= width; distance++) {
	                posx = x + (distance * deltax);
	                posy = y + (distance * deltay);
	                // stop if we go off the board
	                if(posx < 0 || posx >= width || posy < 0 || posy >= height)
	                    break;
	                // stop when we reach an empty square
	                if(board[posx][posy].player == EMPTY)
	                    break;
	                if(board[posx][posy].player == player) {
	                    // backtrack, flipping pieces
	                    for(distance--; distance > 0; distance--) {
	                        posx = x + (distance * deltax);
	                        posy = y + (distance * deltay);
	                        RawPutPiece(posx, posy, player);
							_Gains[_moves] += '#' + posx + ',' + posy;
	                    }
	                    break;
	                }
	            }
	        }
	    }
		_Gains[_moves] = _Gains[_moves].substring(1);
	    return count;
	}

	function AnyMoves(player) {
	    var x, y;

	    for(y = 0; y < height; y++) {
	        for(x = 0; x < width; x++) {
	            if(board[x][y].player != EMPTY) continue;
	            if(NumFlips(x, y, player) > 0) return true;
	        }
	    }
	    return false;
	}

	function CanPutPiece(x, y, player) {
	// determine whether the player can put a piece at the given position
	    if(turn != player)
	        return false;
	    if(board[x][y].player != EMPTY)
	        return false;
	    return NumFlips(x, y, player) > 0;
	}

	this.CheckPutPiece = function(x, y) {
	    var over;
	    if(overhook != "") eval(overhook);

	    if(!showcursor) return;
	    if(!CanPutPiece(x, y, _Human)) return;

	    if(_Human == WHITE) over = WHITETRANS;
	    else over = BLACKTRANS;
	    SetPieceImage(x, y, picture[over].src);
	}

	this.RestorePiece = function(x, y) {
	    if(showflips && RawShowFlipCount(x, y, _Human)) return;
	    SetPieceImage(x, y, picture[board[x][y].player].src);
	}

	this.PutPiece = function(x, y) {
	    if(!CanPutPiece(x, y, _Human)) return;
	    FlipPieces(x, y, _Human);
		MarkMove(x, y, _Human);
	    DoneTurn();
	}
	
	function MarkMove(x, y, human)
	{
		if(_lastMove.x != -1 && _lastMove.y != -1)
		{
			UnmarkMove(_lastMove.x, _lastMove.y);
		}
		var s = document.createElement('span');
		s.style.position = 'absolute';
		s.style.display = 'block';
		s.style.width = _piecewidth + 'px';
		s.style.height = _pieceheight + 'px';
		s.style.margin = '0';
		s.style.fontFamily = 'sans-serif';
		s.style.fontSize = '10px';
		s.style.textAlign = 'center';
		s.style.lineHeight = _pieceheight + 'px';
		s.style.color = human == WHITE ? '#000' : '#FFF';
		var t = document.createTextNode(String(_moves));
		s.appendChild(t);
		document.getElementById(board[x][y].imagename).parentNode.insertBefore(s, document.getElementById(board[x][y].imagename));
		
		_lastMove.x = x;
		_lastMove.y = y;
	}
	
	function UnmarkMove(x, y)
	{
		var k = document.getElementById(board[x][y].imagename).parentNode.firstChild;
		document.getElementById(board[x][y].imagename).parentNode.removeChild(k);
	}
	
	this.MoveBack = function()
	{
		if(turn == EMPTY)
		{
			turn = BLACK;
		}
		if(_moves >= 1 && typeof _History[_moves] != 'undefined')
		{
			_moveBack = true;
			AI_timerID = clearTimeout(AI_timerID);
			SetBackMoves();			
		}
	}
	
	this.MoveForward = function()
	{
		var str = '';
		var coords = [];
		if(_Gameplay.length && _moves < _Gameplay.length)
		{
			coords = _Gameplay[_moves].split(',');
			this.PutPiece(Number(coords[0]), Number(coords[1]));
		}
		else if(!_Gameplay.length && (str = document.getElementById('Game_' + _gameNo).parentNode.getElementsByTagName('input')[0].value) != '')
		{
			ReadGameplay(str);
			coords = _Gameplay[_moves].split(',');
			this.PutPiece(Number(coords[0]), Number(coords[1]));
		}
		else
		{
			ShowMessage(PlayerNoMoves);
		}
	}
	
	function SetBackMoves()
	{
		// remove the set piece
		var lastPiece = _History[_moves].split(',');
		if(humanVsHuman)
		{
			_Human = OtherPlayer(board[lastPiece[0]][lastPiece[1]].player);
		}
		
		// set this place empty
		score[board[lastPiece[0]][lastPiece[1]].player]--;
		SetPieceImage(lastPiece[0], lastPiece[1], picture[EMPTY].src);
		//_History[_moves] = '';
		ShowHistory();
		
		// change the color of the gained pieces
		var discs = _Gains[_moves].split('#');
		_Gains[_moves] = '';
		for(var i=0; i<discs.length; i++)
		{
			var coords = discs[i].split(',');
			if(humanVsHuman)
			{
				SetPieceImage(coords[0], coords[1], picture[_Human].src);
				score[_Human]++;
				board[coords[0]][coords[1]].player = _Human;
			}
			else
			{
				SetPieceImage(coords[0], coords[1], picture[turn].src);
				score[turn]++;
				board[coords[0]][coords[1]].player = turn;
			}
			score[board[lastPiece[0]][lastPiece[1]].player]--;
		}
		board[lastPiece[0]][lastPiece[1]].player = EMPTY;
		_moves--;
		if(_moves >= 1 && typeof _History[_moves] != 'undefined')
		{
			lastPiece = _History[_moves].split(',');
			MarkMove(lastPiece[0], lastPiece[1], _Human);
		}
		else
		{
			UnmarkMove(lastPiece[0], lastPiece[1], _Human);
			_lastMove.x = -1;
			_lastMove.y = -1;
		}
		DoneTurn();
		if(!humanVsHuman && !AI_timerID)
		{
			AI_timerID = setTimeout( function() { SetBackMoves(); }, _Human == EMPTY ? 1000: 150);
		}
		else
		{
			clearTimeout(AI_timerID);
			_moveBack = false;
		}
	}
	
	function ReadGameplay(gameplay)
	{
		var __moves = _moves;
		
		if(gameplay.indexOf('>') != -1)
		{
			var temp = gameplay.split('>');
			gameplay = temp[0];
			_fmoves = Number(temp[1].replace(/\s\s*/g, ''));
		}
		gameplay = gameplay.replace(/\s\s*/g, '').toLowerCase();
		for(var i=0; i<gameplay.length; i+=2)
		{
			var val = gameplay.substr(i, 2).split('');
			_Gameplay[__moves++] = _Notation[val[0]] + ',' + (Number(val[1]) - 1);
		}
		if(_fmoves > 0)
		{
			SetGameStatus();
		}
	}
	
	function SetGameStatus()
	{
		for(var i=0; i<_fmoves; i++)
		{
			setTimeout(function() { _self.MoveForward() }, 100);
		}
	}
	
	function ShowHistory()
	{
		var history = '';
		var lastPiece = [];
		for(var i=0; i<_History.length; i++)
		{
			if(typeof _History[i] != 'undefined' && _History[i] != '')
			{
				lastPiece = _History[i].split(',');
				history += ' ' + _Notation[lastPiece[0]] + String(Number(lastPiece[1]) + 1);
			}
		}
		document.getElementById('Game_' + _gameNo).parentNode.getElementsByTagName('input')[0].value = history;
	}

	function RawShowFlipCount(x, y, player) {
	    var flips;
	    if(board[x][y].player != EMPTY) return false;
	    if((flips = board[x][y].flips[player]) == 0) return false;
	    SetPieceImage(x, y, picture[NUMBASE + flips].src);
	    return true;
	}

	this.ShowFlipCounts = function(player) {
	    CalcFlipCounts();
	    for(var y = 0; y < height; y++) {
	        for(var x = 0; x < width; x++) {
	            RawShowFlipCount(x, y, player);
	        }
	    }
	}

	this.HideFlipCounts = function() {
	    for(var y = 0; y < height; y++) {
	        for(var x = 0; x < width; x++) {
	            if(board[x][y].player == EMPTY)
	                SetPieceImage(x, y, picture[EMPTY].src);
	        }
	    }
	}

	function OtherPlayer(player) {
	    return player == WHITE ? BLACK : WHITE;
	}

	function DoneTurn() {
	    if(turn != EMPTY && _Human != EMPTY)
		{
		    if(turnhook != "") eval(turnhook);
			
			if(humanVsHuman) {
				var hmoves = AnyMoves(_Human);
				_Human = OtherPlayer(_Human);
				ShowScore();
				ShowMessage((_Human == BLACK ? PlayerBlack : PlayerWhite) + PlayerTurn);
				if(!AnyMoves(_Human)) {
			        if(!hmoves && !_moveBack)
					{
						if(score[BLACK] == score[WHITE])
							ShowMessage(Draw);
						else
							ShowMessage((score[BLACK] > score[WHITE] ? PlayerBlack : PlayerWhite) + PlayerHasWon);
						ShowHistory();
						return GameOver();
					}

			        // XXX inform user the player has no move
					ShowMessage((_Human == BLACK ? PlayerBlack : PlayerWhite) + PlayerMustPass);
			        // and switch players again
			        _Human = OtherPlayer(_Human);
				}
			}
			var moves = AnyMoves(turn);
			turn = OtherPlayer(turn);
			ShowScore();
			ShowMessage((_Human == BLACK ? PlayerBlack : PlayerWhite) + PlayerTurn);
			// check whether the new player has any moves
			if(!AnyMoves(turn)) {
				if(!moves && !_moveBack) 
				{
					if(score[BLACK] == score[WHITE])
						ShowMessage(Draw);
					else
						ShowMessage((score[BLACK] > score[WHITE] ? PlayerBlack : PlayerWhite) + PlayerHasWon);
				}

				// XXX inform user the player has no move
				ShowMessage((turn == BLACK ? PlayerBlack : PlayerWhite) + PlayerMustPass);
				// and switch players again
				turn = OtherPlayer(turn);
			}
			
			// add a slight delay before the computer takes it's turn so game feels
			// "warmer"; when computer is playing itself, add larger delay so user
			// can watch
			if(turn != _Human) {
				_self.HideFlipCounts();
				if(!humanVsHuman && !_moveBack)
				{
					AI_timerID = setTimeout( function() { OthelloAI(turn); }, _Human == EMPTY ? 1000: 150);
				}
			}
			else if(showflips)
				_self.ShowFlipCounts(_Human);
		}
	}

	function Rate(x, y, player) {
	    var rating;

	    if(board[x][y].player != EMPTY) return 0;
	    if(x < 0 || x >= width || y < 0 || y >= height) return 0;

	    rating = board[x][y].flips[player];

	    if(!weightsquares)
	        rating = (rating > 0)? 1: 0;

	    if(edgesensitive && rating > 0) {
	        // increase all non-zero weightings by 3 so we have room
	        // to wait 'less ideal' squares below the baseline
	        rating += 10;

	        // raise edge ratings 4 points, corners are raised 8
	        if(x == 0 || x == width - 1) rating += 4;
	        if(y == 0 || y == height - 1) rating += 4;
	        // lower next-to-edge ratings by 5 points, next-to-corner by 10
	        if(x == 1 || x == width - 2) rating -= 5;
	        if(y == 1 || y == height - 2) rating -= 5;

	        // we cannot rule out a move because of bad location; we must
	        // always go somewhere
	        if(rating < 1) rating = 1;
	    }
	    return(rating);
	}

	function OthelloAI(player) {
	    var x, y;
	    var best = 0, numbest = 0;
	    var rating;
	    var pick, count;

	    // rank each position on the board by the potential flip count
	    CalcFlipCounts();

	    // apply AI rating algorithm
	    for(y = 0; y < height; y++) {
	        for(x = 0; x < width; x++) {
	            rating = Rate(x, y, player);

	            // store the rating back into the board
	            board[x][y].value[player] = rating;

	            if(rating == best)
	                numbest++;
	            else if(rating > best) {
	                best = rating;
	                numbest = 1;
	            }
	        }
	    }

	    while(numbest > 0) {
	        // pick a square to put our piece
	        pick = Math.floor(Math.random() * numbest);
	        count = 0;
	        for(y = 0; y < height; y++) {
	            for(x = 0; x < width; x++) {
	                rating = board[x][y].value[player];
	                if(rating == best) {
	                    if(count == pick) {
	                        FlipPieces(x, y, player);
							MarkMove(x, y, player);
	                        DoneTurn();
	                        return;
	                    }
	                    else count++;
	                }
	            }
	        }
	    }

	    // if we make it here, then there was nowhere to go
	    DoneTurn();
	}

	this.Play = function() {
	    // black always goes first
	    if(_Human != BLACK)
	        OthelloAI(BLACK);
	    else if(showflips)
	        this.ShowFlipCounts(_Human);
	}

	function GameOver() {
	    turn = EMPTY;
	}
}

// build the graphical boards in place of the coded boards

var			Boards = [];
var input = null;
window.onload = function() {
	// initialize the state of the board
	// find all gameboards defined in text-format (White = O, Black = #, Empty = .) and assigned with pre-tags
	var pre = document.getElementsByTagName('pre');
	var preN = [];
	// extract the   pre-elements marked with the class "othello-board" and wrapped in the div with class="bpre" from the HTML-collection
	// transfer them into an array to make it easier to replace them later
	for(var i=0; i<pre.length; i++)
	{
		if(pre[i].getAttribute('class') && pre[i].getAttribute('class').indexOf('othello-board-code') > -1)
		{
			preN.push(pre[i]);
		}
	}
	pre = preN;
	delete preN;
	// collect the container elements whre the games shall be inserted
	var divColl = document.getElementsByTagName('div');
	var preDiv = [];
	for(var i=0; i<divColl.length; i++)
	{
		if(divColl[i].getAttribute('class') && divColl[i].getAttribute('class').indexOf('othello-game') > -1)
		{
			preDiv.push(divColl[i]);
		}
	}
	
	// replace the marked pre-elements through a "grafical interface", the Othello game of Kelly Yancey
	if(pre.length && pre.length > 0 && preDiv.length && preDiv.length > 0)
	{
		piecewidth = 20;
		pieceheight = 20;
		for(var i=pre.length-1; i>=0; i--)
		{
			var matrix = pre[i].firstChild.nodeValue.trim();
			var div = document.createElement('div');
			div.setAttribute('id', 'Game_'+i);
			div.setAttribute('class', 'gContainer');
			preDiv.pop().replaceChild(div, pre[i]);
			var gameX = document.getElementById('Game_'+i);
			if(input = document.getElementById('Game_' + i).parentNode.getElementsByTagName('input')[0])
			{
				input.style.display = 'block';
				input.setAttribute('id', 'Input_' + i);
			}
			
			Boards[i] = new OthelloBoard(piecewidth, pieceheight, human, true, true, false, weightsquares, edgesensitive, i);	
			Boards[i].InitializeBoard(gameboardColor, gameX, matrix, 2);
		}
	}
}